diff -ruN ../nakedmudv2.1.1/src/map.h src/map.h
--- ../nakedmudv2.1.1/src/map.h	Sun May  8 15:04:45 2005
+++ src/map.h	Thu May 12 17:08:52 2005
@@ -20,23 +20,23 @@
 //
 // compares is expected to be a function that takes two keys and compares
 // them togher. If they are equal, 0 is returned. if key1 is less than key2,
-// -1 is returned. otherwise, 1 is returned.
-//
-MAP *newMap(void *hash_func, void *compares, int num_buckets);
+// -1 is returned. otherwise, 1 is returned. If this function is NULL, a
+// generic comparator is used that compares memory address of the two keys.
+MAP *newMap(void *hash_func, void *compares);
 void deleteMap(MAP *map);
 
-int   mapPut    (MAP *map, void *key, void *val);
-void *mapGet    (MAP *map, void *key);
-void *mapRemove (MAP *map, void *key);
-int   mapIn     (MAP *map, void *key);
+int   mapPut    (MAP *map, const void *key, void *val);
+void *mapGet    (MAP *map, const void *key);
+void *mapRemove (MAP *map, const void *key);
+int   mapIn     (MAP *map, const void *key);
 int   mapSize   (MAP *map);
 
 MAP_ITERATOR *newMapIterator(MAP *map);
 void          deleteMapIterator(MAP_ITERATOR *I);
 
-void  mapIteratorReset      (MAP_ITERATOR *I);
-void  mapIteratorNext       (MAP_ITERATOR *I);
-void *mapIteratorCurrentKey (MAP_ITERATOR *I);
-void *mapIteratorCurrentVal (MAP_ITERATOR *I);
+void  mapIteratorReset            (MAP_ITERATOR *I);
+void  mapIteratorNext             (MAP_ITERATOR *I);
+void *mapIteratorCurrentVal       (MAP_ITERATOR *I);
+const void *mapIteratorCurrentKey (MAP_ITERATOR *I);
 
 #endif // __MAP_H
diff -ruN ../nakedmudv2.1.1/src/mud.c src/mud.c
--- ../nakedmudv2.1.1/src/mud.c	Sun May  8 15:04:45 2005
+++ src/mud.c	Thu May 12 17:08:52 2005
@@ -12,25 +12,68 @@
 #include "storage.h"
 
 
+//*****************************************************************************
+// local defines, variables, and datastructures
+//*****************************************************************************
+
+//
+// the file where we store all of our mud settings
 #define MUD_DATA       "../lib/muddata"
 
-int top_char_uid = 0;
+//
+// our storage set of mud settings
+STORAGE_SET *settings = NULL;
+
 
 
+//*****************************************************************************
+// implementation of functions in mud.h
+//*****************************************************************************
 void init_mud_settings() {
-  STORAGE_SET *set = storage_read(MUD_DATA);
-  top_char_uid     = read_int(set, "puid");
+  settings = storage_read(MUD_DATA);
+}
+
+void mudsettingSetString(const char *key, const char *val) {
+  store_string(settings,  key, val);
+  storage_write(settings, MUD_DATA);  
+}
+
+void mudsettingSetDouble(const char *key, double val) {
+  store_double(settings, key, val);
+  storage_write(settings, MUD_DATA);
+}
+
+void mudsettingSetInt(const char *key, int val) {
+  store_int(settings, key, val);
+  storage_write(settings, MUD_DATA);
+}
+
+void mudsettingSetLong(const char *key, long val) {
+  store_long(settings, key, val);
+  storage_write(settings, MUD_DATA);
+}
+
+void mudsettingSetBool(const char *key, bool val) {
+  store_bool(settings, key, val);
+  storage_write(settings, MUD_DATA);
+}
+
+const char *mudsettingGetString(const char *key) {
+  return read_string(settings, key);
+}
+
+double mudsettingGetDouble(const char *key) {
+  return read_double(settings, key);
+}
+
+int mudsettingGetInt(const char *key) {
+  return read_int(settings, key);
 }
 
-void save_mud_settings() {
-  STORAGE_SET *set = storage_read(MUD_DATA);
-  store_int(set, "puid", top_char_uid);
-  storage_write(set, MUD_DATA);
-  storage_close(set);
+long mudsettingGetLong(const char *key) {
+  return read_long(settings, key);
 }
 
-int next_char_uid() {
-  int uid = ++top_char_uid;
-  save_mud_settings();
-  return uid;
+bool mudsettingGetBool(const char *key) {
+  return read_bool(settings, key);
 }
diff -ruN ../nakedmudv2.1.1/src/mud.h src/mud.h
--- ../nakedmudv2.1.1/src/mud.h	Sun May  8 15:04:45 2005
+++ src/mud.h	Thu May 12 17:17:41 2005
@@ -38,15 +38,13 @@
 
 
 //*****************************************************************************
-//
 // To avoid having to write some bulky structure names, we've typedef'd a
 // bunch of shortforms for commonly used datatypes. If you make a new datatype
 // that is used lots, put a typedef for it in here.
-//
 //*****************************************************************************
 typedef struct socket_data                SOCKET_DATA;
+typedef struct account_data               ACCOUNT_DATA;
 typedef struct char_data                  CHAR_DATA;  
-typedef struct lookup_data                LOOKUP_DATA;
 typedef struct datatable                  DATATABLE;
 typedef struct storage_set                STORAGE_SET;
 typedef struct storage_set_list           STORAGE_SET_LIST;
@@ -76,7 +74,7 @@
 typedef int                               dialog_vnum;
 typedef long                              bitvector_t;
 
-/* define simple types */
+// define simple types
 #ifndef __cplusplus
 typedef  unsigned char     bool;
 #endif
@@ -129,12 +127,6 @@
 #define EXE_FILE           "../src/NakedMud"      /* the name of the mud binary         */
 #define DEFAULT_PORT       4000                   /* the default port we run on */
 
-// if it is safe to run the game loop in a separate
-// thread (this makes it so we can run scripts in a separate
-// thread as well) then keep this on. Otherwise, comment out
-// this line
-//#define MUD_THREADABLE
-
 /* Thread States */
 #define TSTATE_LOOKUP          0  /* Socket is in host_lookup        */
 #define TSTATE_DONE            1  /* The lookup is done.             */
@@ -142,11 +134,12 @@
 #define TSTATE_CLOSED          3  /* Closed, ready to be recycled.   */
 
 /* player levels */
-#define LEVEL_PLAYER           1  // All of the normal players
-#define LEVEL_BUILDER          2  // Players who have building rights
-#define LEVEL_SCRIPTER         3  // Players who have building+scripting rights
-#define LEVEL_ADMIN            4  // The people who oversee the MUD
-#define MAX_LEVEL      LEVEL_ADMIN
+#define LEVEL_PLAYER           1           // All of the normal players
+#define LEVEL_GOD              2           // All the people who run the show
+#define LEVEL_BUILDER          LEVEL_GOD   // Players who have building rights
+#define LEVEL_SCRIPTER         3           // Builders who have scripting rights
+#define LEVEL_ADMIN            4           // The people who oversee the MUD
+#define MAX_LEVEL              LEVEL_ADMIN
 
 /* Communication Ranges */
 #define COMM_LOCAL             0  /* same room only                  */
@@ -163,24 +156,13 @@
 #define SOMEONE         "someone"
 #define NOTHING_SPECIAL "you see nothing special."
 
+// the room that new characters are dropped into
 #define START_ROOM      100
 
 #define WORLD_PATH     "../lib/world"
 
 
 
-//*****************************************************************************
-// New structures
-//*****************************************************************************
-
-// required for looking up a socket's IP in a new thread
-struct lookup_data
-{
-  SOCKET_DATA       * dsock;   /* the socket we wish to do a hostlookup on */
-  char           * buf;     /* the buffer it should be stored in        */
-};
-
-
 
 //*****************************************************************************
 // core functions for working with new commands
@@ -200,6 +182,33 @@
 
 
 //*****************************************************************************
+// functions for setting and retreiving values of various mud settings. It's
+// probably going to be common for people to add new settings that change how
+// their mud will run (e.g. wizlock, newlock, max_level). Forcing people to
+// handle all of this stuff through modules is really giving them more work
+// than is neccessary. Instead, here we have a set of utilities that makes 
+// doing this sort of stuff really easy. Whenever a new value is set, the
+// settings are automagically saved. New variables can be created on the fly.
+// There is no need to define keys anywhere. Conversion between types is
+// handled automatically.
+//*****************************************************************************
+void init_mud_settings();
+
+void mudsettingSetString(const char *key, const char *val);
+void mudsettingSetDouble(const char *key, double val);
+void mudsettingSetInt   (const char *key, int val);
+void mudsettingSetLong  (const char *key, long val);
+void mudsettingSetBool  (const char *key, bool val);
+
+const char *mudsettingGetString(const char *key);
+double      mudsettingGetDouble(const char *key);
+int         mudsettingGetInt   (const char *key);
+long        mudsettingGetLong  (const char *key);
+bool        mudsettingGetBool  (const char *key);
+
+
+
+//*****************************************************************************
 // Global Variables
 //*****************************************************************************
 extern  LIST           *object_list;
@@ -244,6 +253,11 @@
 /* interpret.c */
 void  handle_cmd_input        ( SOCKET_DATA *dsock, char *arg );
 
+/* account_hanlder.c */
+void account_handle_menu      ( SOCKET_DATA *sock, char *arg);
+void account_menu             ( SOCKET_DATA *sock);
+
+
 //
 // Some command scripts may want to re-force a character to
 // perform the command. In that case, scripts_ok can be
@@ -273,11 +287,6 @@
 /* mccp.c */
 bool  compressStart     ( SOCKET_DATA *dsock, unsigned char teleopt );
 bool  compressEnd       ( SOCKET_DATA *dsock, unsigned char teleopt, bool forced );
-
-/* mud.c */
-void init_mud_settings();
-void save_mud_settings();
-int next_char_uid();
 
 /* socket.c */
 #define NUM_LINES_PER_PAGE  22
diff -ruN ../nakedmudv2.1.1/src/object.c src/object.c
--- ../nakedmudv2.1.1/src/object.c	Sun May  8 15:04:45 2005
+++ src/object.c	Thu May 12 17:08:52 2005
@@ -55,8 +55,7 @@
 
 
 OBJ_DATA *newObj() {
-  OBJ_DATA *obj = malloc(sizeof(OBJ_DATA));
-  bzero(obj, sizeof(*obj));
+  OBJ_DATA *obj = calloc(1, sizeof(OBJ_DATA));
   obj->uid            = next_obj_uid++;
   obj->vnum           = NOTHING;
 
diff -ruN ../nakedmudv2.1.1/src/olc2/accedit.c src/olc2/accedit.c
--- ../nakedmudv2.1.1/src/olc2/accedit.c	Wed Dec 31 17:00:00 1969
+++ src/olc2/accedit.c	Thu May 12 17:08:51 2005
@@ -0,0 +1,121 @@
+//*****************************************************************************
+//
+// accedit.c
+//
+// Accedit allows admins to edit player accounts online. Passwords and
+// character lists can be edited.
+//
+//*****************************************************************************
+#include "../mud.h"
+#include "../utils.h"
+#include "../account.h"
+#include "../socket.h"
+#include "../character.h"
+#include "../save.h"
+
+#include "olc.h"
+
+
+
+//*****************************************************************************
+// account editing
+//*****************************************************************************
+#define ACCEDIT_NEW_CHAR      1
+#define ACCEDIT_DELETE_CHAR   2
+#define ACCEDIT_PASSWORD      3
+
+
+//
+// Saves the account, updates all of the accounts with this name currently
+// in use, and deletes the account we're working with from memory.
+void accedit_cleanup(ACCOUNT_DATA *acct) {
+  LIST_ITERATOR *sock_i = newListIterator(socket_list);
+  SOCKET_DATA   *sock   = NULL;
+
+  // first, update all of the accounts online
+  ITERATE_LIST(sock, sock_i) {
+    if(socketGetAccount(sock) &&
+       !strcasecmp(accountGetName(socketGetAccount(sock)),
+		   accountGetName(acct)))
+      accountCopyTo(acct, socketGetAccount(sock));
+  } deleteListIterator(sock_i);
+
+  // now, save the account
+  save_account(acct);
+  // and free up the memory
+  deleteAccount(acct);
+}
+
+
+void accedit_menu(SOCKET_DATA *sock, ACCOUNT_DATA *acct) {
+  LIST_ITERATOR *ch_i = newListIterator(accountGetChars(acct));
+  char            *ch = NULL;
+  send_to_socket(sock, "{g[{c%s{g]\r\n", accountGetName(acct));
+  send_to_socket(sock, "Character list:{c\r\n");
+  ITERATE_LIST(ch, ch_i) {
+    send_to_socket(sock, "  %s\r\n", ch);
+  } deleteListIterator(ch_i);
+  send_to_socket(sock, 
+		 "\r\n"
+		 "{cN{n) Add new character\r\n"
+		 "{cD{n) Delete character from account\r\n"
+		 "{cP{n) Change password\r\n");
+}
+
+int accedit_chooser(SOCKET_DATA *sock, ACCOUNT_DATA *acct, const char *option) {
+  switch(toupper(*option)) {
+  case 'N':
+    text_to_buffer(sock, "Enter character's name: ");
+    return ACCEDIT_NEW_CHAR;
+  case 'D':
+    text_to_buffer(sock, "Enter character's name: ");
+    return ACCEDIT_DELETE_CHAR;
+  case 'P':
+    text_to_buffer(sock, "Enter new password: ");
+    return ACCEDIT_PASSWORD;
+  default:
+    return MENU_CHOICE_INVALID;
+  }
+}
+
+bool accedit_parser(SOCKET_DATA *sock, ACCOUNT_DATA *acct, int choice, 
+		  const char *arg) {
+  switch(choice) {
+  case ACCEDIT_NEW_CHAR:
+    if(!char_exists(arg))
+      return FALSE;
+    else {
+      listPutWith(accountGetChars(acct), strdup(arg), strcasecmp);
+      return TRUE;
+    }
+  case ACCEDIT_DELETE_CHAR: {
+    char *name = listRemoveWith(accountGetChars(acct), arg, strcasecmp);
+    if(name != NULL) free(name);
+    return TRUE;
+  }
+  case ACCEDIT_PASSWORD:
+    // make sure the password meets our length requirements
+    if(strlen(arg) < 4 || strlen(arg) > 12)
+      return FALSE;
+    else {
+      accountSetPassword(acct, crypt(arg, accountGetName(acct)));
+      return TRUE;
+    }
+  default:
+    return FALSE;
+  }
+}
+
+COMMAND(cmd_accedit) {
+  if(!arg || !*arg)
+    send_to_char(ch, "You must supply an account name, first!\r\n");
+  else {
+    ACCOUNT_DATA *acct = load_account(arg);
+    if(acct == NULL)
+      send_to_char(ch, "Account '%s' does not exist!\r\n", arg);
+    else {
+      do_olc(charGetSocket(ch), accedit_menu, accedit_chooser, accedit_parser,
+	     NULL, NULL, NULL, accedit_cleanup, acct);
+    }
+  }
+}
diff -ruN ../nakedmudv2.1.1/src/olc2/accedit.d src/olc2/accedit.d
--- ../nakedmudv2.1.1/src/olc2/accedit.d	Wed Dec 31 17:00:00 1969
+++ src/olc2/accedit.d	Thu May 12 17:17:48 2005
@@ -0,0 +1,3 @@
+olc2/accedit.d olc2/accedit.o: olc2/accedit.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h utils.h account.h socket.h \
+  character.h save.h olc2/olc.h
diff -ruN ../nakedmudv2.1.1/src/olc2/module.mk src/olc2/module.mk
--- ../nakedmudv2.1.1/src/olc2/module.mk	Sun May  8 15:04:44 2005
+++ src/olc2/module.mk	Thu May 12 17:08:51 2005
@@ -1,2 +1,2 @@
 SRC  += olc2/olc.c olc2/redit.c olc2/zedit.c olc2/esedit.c olc2/dedit.c \
-	olc2/medit.c olc2/oedit.c olc2/bedit.c
+	olc2/medit.c olc2/oedit.c olc2/bedit.c olc2/accedit.c
diff -ruN ../nakedmudv2.1.1/src/olc2/olc.c src/olc2/olc.c
--- ../nakedmudv2.1.1/src/olc2/olc.c	Sun May  8 15:04:44 2005
+++ src/olc2/olc.c	Thu May 12 17:08:51 2005
@@ -236,6 +236,7 @@
   extern COMMAND(cmd_dedit);
   extern COMMAND(cmd_medit);
   extern COMMAND(cmd_oedit);
+  extern COMMAND(cmd_accedit);
   add_cmd("zedit", NULL, cmd_zedit, 0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_BUILDER, FALSE, TRUE);
   add_cmd("redit", NULL, cmd_redit, 0, POS_UNCONCIOUS, POS_FLYING,
@@ -246,6 +247,8 @@
 	  LEVEL_BUILDER, FALSE, TRUE);
   add_cmd("oedit", NULL, cmd_oedit, 0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_BUILDER, FALSE, TRUE);
+  add_cmd("accedit", NULL, cmd_accedit, 0, POS_UNCONCIOUS, POS_FLYING,
+	  LEVEL_ADMIN,   FALSE, TRUE);
 }
 
 void do_olc(SOCKET_DATA *sock,
diff -ruN ../nakedmudv2.1.1/src/room_reset.c src/room_reset.c
--- ../nakedmudv2.1.1/src/room_reset.c	Sun May  8 15:04:45 2005
+++ src/room_reset.c	Thu May 12 17:08:52 2005
@@ -64,8 +64,7 @@
 
 
 RESET_DATA    *newReset         () {
-  RESET_DATA *reset = malloc(sizeof(RESET_DATA));
-  bzero(reset, sizeof(RESET_DATA));
+  RESET_DATA *reset = calloc(1, sizeof(RESET_DATA));
   reset->type     = RESET_LOAD_OBJECT;
   reset->arg      = strdup("");
   reset->times    = 1;
diff -ruN ../nakedmudv2.1.1/src/save.c src/save.c
--- ../nakedmudv2.1.1/src/save.c	Sun May  8 15:04:45 2005
+++ src/save.c	Thu May 12 17:08:52 2005
@@ -1,12 +1,16 @@
-#include <stdio.h>
-#include <unistd.h>
-#include <stdlib.h>
-#include <string.h>
-#include <ctype.h>
+//*****************************************************************************
+//
+// save.c
+//
+// contains all of the functions for the saving of characters and accounts.
+// makes sure these things go into the right directories.
+//
+//*****************************************************************************
 
-/* main header file */
 #include "mud.h"
+#include "socket.h"
 #include "character.h"
+#include "account.h"
 #include "world.h"
 #include "utils.h"
 #include "handler.h"
@@ -16,19 +20,18 @@
 #include "storage.h"
 
 
-void save_pfile           ( CHAR_DATA *ch );
-void save_objfile         ( CHAR_DATA *ch );
-void save_profile         ( CHAR_DATA *ch );
 
+//*****************************************************************************
+// local functions
+//*****************************************************************************
 
 //
 // Just a general function for finding the filename assocciated with the
 // given information about a player.
-//
-#define FILETYPE_PROFILE      0
-#define FILETYPE_PFILE        1
-#define FILETYPE_OFILE        2
-const char *get_char_filename(const char *name, int filetype) {
+#define FILETYPE_PFILE        0
+#define FILETYPE_OFILE        1
+#define FILETYPE_ACCOUNT      2
+const char *get_save_filename(const char *name, int filetype) {
   static char buf[SMALL_BUFFER];
   static char pname[SMALL_BUFFER];
   int i, size;
@@ -42,8 +45,8 @@
   pname[i] = '\0';
 
   switch(filetype) {
-  case FILETYPE_PROFILE:
-    sprintf(buf, "../lib/players/profiles/%c/%s.profile", *pname, pname);
+  case FILETYPE_ACCOUNT:
+    sprintf(buf, "../lib/accounts/%c/%s.acct", *pname, pname);
     break;
   case FILETYPE_PFILE:
     sprintf(buf, "../lib/players/pfiles/%c/%s.pfile", *pname, pname);
@@ -59,55 +62,40 @@
   return buf;
 }
 
-
-void save_player(CHAR_DATA *ch) {
-  if (!ch) return;
-
-  // make sure we have a UID for the character before we start saving
-  if(charGetUID(ch) == NOBODY) {
-    log_string("ERROR: %s has invalid UID (%d)", charGetName(ch), NOBODY);
-    send_to_char(ch, "You have an invalid ID. Please inform a god.\r\n");
-    return;
-  }
-
-  save_objfile(ch);    // save the player's objects
-  save_pfile(ch);      // saves the actual player data
-  save_profile(ch);    // saves the players profile
-}
-
-
-void save_objfile(CHAR_DATA *ch) {
-  STORAGE_SET *set = new_storage_set();
-  // write all of the inventory
-  store_list(set, "inventory", gen_store_list(charGetInventory(ch), objStore));
-  
-  // for equipped items, it's not so easy - we also have to record
-  // whereabouts on the body the equipment was worn on
-  STORAGE_SET_LIST *list = new_storage_list();
-  LIST *eq_list = bodyGetAllEq(charGetBody(ch));
-  OBJ_DATA *obj = NULL;
-  while((obj = listPop(eq_list)) != NULL) {
-    STORAGE_SET *eq_set = objStore(obj);
-    store_string(set, "equipped", bodyEquippedWhere(charGetBody(ch), obj));
-    storage_list_put(list, eq_set);
+bool char_exists(const char *name) {
+  // there's two ways a character can exists. Either someone is already making
+  // a character with that name, or there is a character with that name in
+  // storage. We'll check both of these.
+  const char *fname = get_save_filename(name, FILETYPE_PFILE);
+  FILE *fl = fopen(fname, "r");
+  if(fl != NULL) {
+    fclose(fl);
+    return TRUE;
   }
-  deleteList(eq_list);
 
-  store_list(set, "equipment", list);
-  storage_write(set, get_char_filename(charGetName(ch), FILETYPE_OFILE));
-  storage_close(set);
+  bool char_found       = FALSE;
+  LIST_ITERATOR *sock_i = newListIterator(socket_list);
+  SOCKET_DATA     *sock = NULL;
+  ITERATE_LIST(sock, sock_i) {
+    CHAR_DATA *ch = socketGetChar(sock);
+    if(ch == NULL) continue;
+    if(!strcasecmp(charGetName(ch), name)) {
+      char_found = TRUE;
+      break;
+    }
+  } deleteListIterator(sock_i);
+  return char_found;
 }
 
-
 void save_pfile(CHAR_DATA *ch) {
   STORAGE_SET *set = charStore(ch);
-  storage_write(set, get_char_filename(charGetName(ch), FILETYPE_PFILE));
+  storage_write(set, get_save_filename(charGetName(ch), FILETYPE_PFILE));
   storage_close(set);
 }
 
 
 void load_ofile(CHAR_DATA *ch) {
-  STORAGE_SET *set = storage_read(get_char_filename(charGetName(ch), 
+  STORAGE_SET *set = storage_read(get_save_filename(charGetName(ch), 
 						    FILETYPE_OFILE));
   if(set == NULL)
     return;
@@ -133,43 +121,70 @@
   storage_close(set);
 }
 
+void save_objfile(CHAR_DATA *ch) {
+  STORAGE_SET *set = new_storage_set();
+  // write all of the inventory
+  store_list(set, "inventory", gen_store_list(charGetInventory(ch), objStore));
+  
+  // for equipped items, it's not so easy - we also have to record
+  // whereabouts on the body the equipment was worn on
+  STORAGE_SET_LIST *list = new_storage_list();
+  LIST *eq_list = bodyGetAllEq(charGetBody(ch));
+  OBJ_DATA *obj = NULL;
+  while((obj = listPop(eq_list)) != NULL) {
+    STORAGE_SET *eq_set = objStore(obj);
+    store_string(set, "equipped", bodyEquippedWhere(charGetBody(ch), obj));
+    storage_list_put(list, eq_set);
+  }
+  deleteList(eq_list);
+
+  store_list(set, "equipment", list);
+  storage_write(set, get_save_filename(charGetName(ch), FILETYPE_OFILE));
+  storage_close(set);
+}
+
+
 
+//*****************************************************************************
+// implementation of save.h
+//*****************************************************************************
 CHAR_DATA *load_player(const char *player) {
-  STORAGE_SET *set = storage_read(get_char_filename(player, FILETYPE_PFILE));
+  STORAGE_SET *set = storage_read(get_save_filename(player, FILETYPE_PFILE));
   CHAR_DATA   *ch  = charRead(set);
   storage_close(set);
   load_ofile(ch);
   return ch;
 }
 
+void save_player(CHAR_DATA *ch) {
+  if (!ch) return;
 
-/*
- * This function loads a players profile, and stores
- * it in a mobile_data... DO NOT USE THIS DATA FOR
- * ANYTHING BUT CHECKING PASSWORDS OR SIMILAR.
- */
-CHAR_DATA *load_profile(const char *player) {
-  STORAGE_SET *set = storage_read(get_char_filename(player, FILETYPE_PROFILE));
-  if(set == NULL) return NULL;
-  CHAR_DATA    *ch = newChar();
-  charSetName(ch,     read_string(set, "name"));
-  charSetPassword(ch, read_string(set, "password"));
-  charSetUID(ch,       read_int  (set, "uid"));
+  // make sure we have a UID for the character before we start saving
+  if(charGetUID(ch) == NOBODY) {
+    log_string("ERROR: %s has invalid UID (%d)", charGetName(ch), NOBODY);
+    send_to_char(ch, "You have an invalid ID. Please inform a god.\r\n");
+    return;
+  }
+
+  save_objfile(ch);    // save the player's objects
+  save_pfile(ch);      // saves the actual player data
+}
+
+void save_account(ACCOUNT_DATA *account) {
+  if(!account) return;
+  STORAGE_SET *set = accountStore(account);
+  storage_write(set, get_save_filename(accountGetName(account),
+				       FILETYPE_ACCOUNT));
   storage_close(set);
-  return ch;
 }
 
+ACCOUNT_DATA *load_account(const char *account) {
+  STORAGE_SET   *set = storage_read(get_save_filename(account,
+						      FILETYPE_ACCOUNT));
+  if(set == NULL)
+    return NULL;
 
-/*
- * This file stores only data vital to load
- * the character, and check for things like
- * password and other such data.
- */
-void save_profile(CHAR_DATA *ch) {
-  STORAGE_SET *set = new_storage_set();
-  store_string(set, "name",     charGetName(ch));
-  store_string(set, "password", charGetPassword(ch));
-  store_int   (set, "uid",      charGetUID(ch));
-  storage_write(set, get_char_filename(charGetName(ch), FILETYPE_PROFILE));
+  ACCOUNT_DATA *acct = accountRead(set);
   storage_close(set);
+  return acct;
 }
diff -ruN ../nakedmudv2.1.1/src/save.d src/save.d
--- ../nakedmudv2.1.1/src/save.d	Sun May  8 15:04:45 2005
+++ src/save.d	Thu May 12 17:17:53 2005
@@ -1,3 +1,3 @@
 save.d save.o: save.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
-  set.h buffer.h bitvector.h character.h world.h utils.h handler.h body.h \
-  object.h room.h storage.h
+  set.h buffer.h bitvector.h socket.h character.h account.h world.h \
+  utils.h handler.h body.h object.h room.h storage.h
diff -ruN ../nakedmudv2.1.1/src/save.h src/save.h
--- ../nakedmudv2.1.1/src/save.h	Sun May  8 15:04:45 2005
+++ src/save.h	Thu May 12 17:08:52 2005
@@ -8,10 +8,10 @@
 //
 //*****************************************************************************
 
-
-
-void        save_player ( CHAR_DATA *ch );
-CHAR_DATA  *load_player ( const char *player );
-CHAR_DATA  *load_profile( const char *player );
+void          save_account(ACCOUNT_DATA *account);
+ACCOUNT_DATA *load_account(const char   *account);
+bool          char_exists (const char   *name);
+CHAR_DATA    *load_player (const char   *player);
+void          save_player (CHAR_DATA    *ch);
 
 #endif // __SAVE_H
diff -ruN ../nakedmudv2.1.1/src/scripts/script_edit.c src/scripts/script_edit.c
--- ../nakedmudv2.1.1/src/scripts/script_edit.c	Sun May  8 15:04:44 2005
+++ src/scripts/script_edit.c	Thu May 12 17:08:51 2005
@@ -67,6 +67,8 @@
 		    const char *arg) {
   switch(choice) {
   case SSEDIT_NEW: {
+    if(atoi(arg) == NOTHING)
+      return TRUE;
     SCRIPT_DATA *script = worldGetScript(gameworld, atoi(arg));
     if(script == NULL)
       return FALSE;
diff -ruN ../nakedmudv2.1.1/src/set_val/set_val.c src/set_val/set_val.c
--- ../nakedmudv2.1.1/src/set_val/set_val.c	Sun May  8 15:04:44 2005
+++ src/set_val/set_val.c	Thu May 12 17:08:51 2005
@@ -28,9 +28,14 @@
 
 
 //*****************************************************************************
-//
+// mandatory modules
+//*****************************************************************************
+#include "../editor/editor.h" // for charGetNotepad
+
+
+
+//*****************************************************************************
 // local defines, datastructures, functions, and commands
-//
 //*****************************************************************************
 HASHTABLE *char_set_table = NULL;
 HASHTABLE *obj_set_table  = NULL;
@@ -115,25 +120,23 @@
 // vnum, or simply "room" for the current room. Optionally, the function can
 // take a value from the player's notepad instead of from the command line (this
 // is useful for if you need to write long lengths of formatted text).
-//
 COMMAND(cmd_set) {
   char name [SMALL_BUFFER];
   char field[SMALL_BUFFER];
-  arg = two_args(arg, name, field);
+  const char *val = two_args(arg, name, field);
 
   // check to see if we're trying to set from our notepad. Also, make sure
   // we have a socket and CAN access our notepad.
-  /*
   if(subcmd == SET_SUBCMD_SETPAD) {
-    if(charGetSocket(ch) && *socketGetNotepadPtr(charGetSocket(ch)) != NULL)
-      arg = *socketGetNotepadPtr(charGetSocket(ch));
+    if(charGetSocket(ch) && *socketGetNotepad(charGetSocket(ch)))
+      val = socketGetNotepad(charGetSocket(ch));
     else {
       send_to_char(ch, "Your notepad currently has no contents.\r\n");
       return;
     }
   }
-  */
-  if(!*arg || !*name || !*field)
+
+  if(!*val || !*name || !*field)
     send_to_char(ch, "Set which value on what?\r\n");
   // are we trying to set a field on a room?
   else if(!strcasecmp("room", name)) {
@@ -141,13 +144,13 @@
 		    ch))
       send_to_char(ch, "You are not authorized to edit this zone.\r\n");
     else
-      try_set(ch, charGetRoom(ch), room_set_table, field, arg);
+      try_set(ch, charGetRoom(ch), room_set_table, field, val);
   }
   else if(isdigit(*name) && worldGetRoom(gameworld, atoi(name))) {
     if(!canEditZone(worldZoneBounding(gameworld, atoi(name)), ch))
       send_to_char(ch, "You are not authorized to edit this zone.\r\n");
     else
-      try_set(ch, worldGetRoom(gameworld, atoi(name)),room_set_table,field,arg);
+      try_set(ch, worldGetRoom(gameworld, atoi(name)),room_set_table,field,val);
   }
   else {
     int found = FOUND_NONE;
@@ -160,10 +163,10 @@
 	send_to_char(ch, "Sorry, %s is too high a level!\r\n", 
 		     see_char_as(ch, tgt));
       else
-	try_set(ch, tgt, char_set_table, field, arg);
+	try_set(ch, tgt, char_set_table, field, val);
     }
     else if(found == FOUND_OBJ)
-      try_set(ch, tgt, obj_set_table, field, arg);
+      try_set(ch, tgt, obj_set_table, field, val);
     else
       send_to_char(ch, "What was the target you were trying to modify?\r\n");
   }
diff -ruN ../nakedmudv2.1.1/src/set_val/set_val.d src/set_val/set_val.d
--- ../nakedmudv2.1.1/src/set_val/set_val.d	Sun May  8 15:05:26 2005
+++ src/set_val/set_val.d	Thu May 12 17:17:49 2005
@@ -1,4 +1,4 @@
 set_val/set_val.d set_val/set_val.o: set_val/set_val.c mud.h wrapsock.h property_table.h list.h \
   map.h hashtable.h set.h buffer.h bitvector.h utils.h world.h zone.h \
   socket.h character.h object.h room.h races.h handler.h \
-  set_val/set_val.h
+  set_val/set_val.h editor/editor.h
